SystemOrganization addCategory: #'Ma time objects-Experimental'!
SystemOrganization addCategory: #'Ma time objects-Info'!
SystemOrganization addCategory: #'Ma time objects-Kernel'!
SystemOrganization addCategory: #'Ma time objects-exceptions'!

MaObject subclass: #MaProgressor
	instanceVariableNames: 'description stopwatch taskSize unitsCompleted unitsVerbPhrase log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 8/6/2003 00:44'!
addLogMessage: aString

	log add: aString! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:29'!
advance

	unitsCompleted _ unitsCompleted + 1! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 11/13/2003 00:40'!
advance: anInteger

	unitsCompleted _ unitsCompleted + anInteger! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 7/20/2004 20:47'!
description
	"A message from the domain."
	^description! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:06'!
description: aString

	description _ aString! !

!MaProgressor methodsFor: 'private' stamp: 'cmm 7/19/2004 23:06'!
initialize

	super initialize.
	stopwatch _ MaStopwatch new.
	unitsVerbPhrase _ ' units processed.'.
	unitsCompleted _ 0.
	log _ OrderedCollection new.
	description _ 'not running.'! !

!MaProgressor methodsFor: 'testing' stamp: 'cmm 6/30/2003 16:21'!
isRunning

	^stopwatch isRunning! !

!MaProgressor methodsFor: 'testing' stamp: 'cmm 8/7/2003 17:06'!
knowsTaskSize

	^self taskSize notNil and: [ self taskSize > 0 ]! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:30'!
percentComplete
	"Answers a Float between 0.0 and 1.0."

	^self knowsTaskSize
		ifTrue: [ (unitsCompleted / taskSize) asFloat ]
		ifFalse: [ 0.0 ]! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 8/6/2003 14:31'!
progressMessage

	^String streamContents:
		[ : stream |
		stream maPrint: self unitsCompleted.
		self knowsTaskSize
			ifTrue:
				[ stream
					maPrint: ' of ';
					maPrint: self taskSize ].
		stream space.
		stream maPrint: self unitsVerbPhrase ] ! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 1/19/2004 00:17'!
rateMessage

	^String streamContents:
		[ : stream |
		stream
			maPrint: self ratePerSecond;
			maPrint: ' / second in ';
			maPrint: stopwatch time abbreviatedString ]! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 12/18/2004 18:46'!
ratePerSecond

	| totalMilliseconds |
	^ (totalMilliseconds _ self runningTime totalMilliseconds) > 0
		ifTrue: [ (self unitsCompleted * 1000 / totalMilliseconds) asFloat roundTo: 0.1 ]
		ifFalse: [ 0.0 ]! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 8/6/2003 12:45'!
remainingTime

	self maMarked: 'dev'! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:33'!
runningTime

	^stopwatch time! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:28'!
start

	stopwatch start! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:04'!
startTime

	^stopwatch startTime! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/30/2003 16:18'!
stop

	stopwatch stop! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:27'!
taskSize

	^taskSize! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:27'!
taskSize: anInteger

	taskSize _ anInteger! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:32'!
unitsCompleted

	^unitsCompleted! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:33'!
unitsCompleted: anInteger

	unitsCompleted _ anInteger! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:32'!
unitsVerbPhrase

	^unitsVerbPhrase! !

!MaProgressor methodsFor: 'accessing' stamp: 'cmm 6/29/2003 23:28'!
unitsVerbPhrase: aString

	unitsVerbPhrase _ aString! !

!MaProgressor methodsFor: 'updating' stamp: 'cmm 11/13/2003 00:41'!
updateFrom: aMaProgressNotification

	self advance: aMaProgressNotification advanceCount.
	aMaProgressNotification hasDescription ifTrue: [ self description: aMaProgressNotification description ].
	aMaProgressNotification hasTaskSize ifTrue: [ self taskSize: aMaProgressNotification taskSize ].
	aMaProgressNotification hasUnitsCompleted ifTrue: [ self unitsCompleted: aMaProgressNotification unitsCompleted ].
	aMaProgressNotification hasUnitsVerbPhrase ifTrue: [ self unitsVerbPhrase: aMaProgressNotification unitsVerbPhrase ].
	aMaProgressNotification hasLogMessage ifTrue: [ self addLogMessage: aMaProgressNotification logMessage ]! !

MaObject subclass: #MaTimeZone
	instanceVariableNames: 'name abbreviation locations offset'
	classVariableNames: 'AllTimeZones LocalTimeZone'
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaTimeZone class methodsFor: 'accessing' stamp: 'cmm 8/30/2004 14:07'!
findTimeZone: aString

	^ self timeZones detect: 
		[ : each | 
		each abbreviation = aString
		or: [ each name includesSubstring: aString caseSensitive: false ] ]! !

!MaTimeZone class methodsFor: 'accessing' stamp: 'cmm 8/30/2004 14:12'!
gmt

	^ self timeZoneAbbreviated: 'GMT'! !

!MaTimeZone class methodsFor: 'initialize' stamp: 'cmm 8/30/2004 12:45'!
initialize

	super initialize.
	self initializeAllTimeZones! !

!MaTimeZone class methodsFor: 'initialize' stamp: 'cmm 8/30/2004 12:44'!
initializeAllTimeZones
	"This information was obtained from http://www.timeanddate.com/library/abbreviations/timezones/"
	AllTimeZones _ OrderedCollection new.
	AllTimeZones
		add: (MaTimeZone name: 'Alpha Time Zone' abbreviation: 'A' offset: 1 maHour) ;
		add: (MaTimeZone name: 'Australian Central Daylight Time' abbreviation: 'ACDT' offset: 10 maHours + 30 maMinutes) ;
		add: (MaTimeZone name: 'Australian Central Standard Time' abbreviation: 'ACST' offset: 9 maHours + 30 maMinutes) ;
		add: (MaTimeZone name: 'Atlantic Daylight Time' abbreviation: 'ADT' offset: -3 maHours) ;
		add: (MaTimeZone name: 'Australian Eastern Daylight Time' abbreviation: 'AEDT' offset: 11 maHours) ;
		add: (MaTimeZone name: 'Australian Eastern Standard Time' abbreviation: 'AEST' offset: 10 maHours) ;
		add: (MaTimeZone name: 'Alaska Daylight Time' abbreviation: 'AKDT' offset: -8 maHours) ;
		add: (MaTimeZone name: 'Alaska Standard Time' abbreviation: 'AKST' offset: -9 maHours) ;
		add: (MaTimeZone name: 'Atlantic Standard Time' abbreviation: 'AST' offset: -4 maHours) ;
		add: (MaTimeZone name: 'Australian Western Standard Time' abbreviation: 'AWST' offset: 8 maHours) ;
		add: (MaTimeZone name: 'Bravo Time Zone' abbreviation: 'B' offset: 2 maHours) ;
		add: (MaTimeZone name: 'British Summer Time' abbreviation: 'BST' offset: 1 maHours) ;
		add: (MaTimeZone name: 'Charlie Time Zone' abbreviation: 'C' offset: 3 maHours) ;
		add: (MaTimeZone name: 'Central Daylight Time (Australia)' abbreviation: 'CDT' offset: 10 maHours + 30 maMinutes) ;
		add: (MaTimeZone name: 'Central Daylight Time (North America)' abbreviation: 'CDT' offset: -5 maHours) ;
		add: (MaTimeZone name: 'Central European Summer Time' abbreviation: 'CEST' offset: 2 maHours) ;
		add: (MaTimeZone name: 'Central European Time' abbreviation: 'CET' offset: 1 maHours) ;
		add: (MaTimeZone name: 'Central Standard Time (Australia)' abbreviation: 'CST' offset: 9 maHours + 30 maMinutes) ;
		add: (MaTimeZone name: 'Central Standard Time (North America)' abbreviation: 'CST' offset: -6 maHours) ;
		add: (MaTimeZone name: 'Christmas Island Time' abbreviation: 'CXT' offset: 7 maHours) ;
		add: (MaTimeZone name: 'Delta Time Zone' abbreviation: 'D' offset: 4 maHours) ;
		add: (MaTimeZone name: 'Echo Time Zone' abbreviation: 'E' offset: 5 maHours) ;
		add: (MaTimeZone name: 'Eastern Daylight Time (Australia)' abbreviation: 'EDT' offset: 11 maHours) ;
		add: (MaTimeZone name: 'Eastern Daylight Time (North America)' abbreviation: 'EDT' offset: -4 maHours) ;
		add: (MaTimeZone name: 'Eastern European Summer Time' abbreviation: 'EEST' offset: 3 maHours) ;
		add: (MaTimeZone name: 'Eastern European Time' abbreviation: 'EET' offset: 2 maHours) ;
		add: (MaTimeZone name: 'Eastern Standard Time (Australia)' abbreviation: 'EST' offset: 10 maHours) ;
		add: (MaTimeZone name: 'Eastern Standard Time (North America)' abbreviation: 'EST' offset: -5 maHours) ;
		add: (MaTimeZone name: 'Foxtrot Time Zone' abbreviation: 'F' offset: 6 maHours) ;
		add: (MaTimeZone name: 'Golf Time Zone' abbreviation: 'G' offset: 7 maHours) ;
		add: (MaTimeZone name: 'Greenwich Mean Time' abbreviation: 'GMT' offset: 0 maHours) ;
		add: (MaTimeZone name: 'Hotel Time Zone' abbreviation: 'H' offset: 8 maHours) ;
		add: (MaTimeZone name: 'India Time Zone' abbreviation: 'I' offset: 9 maHours) ;
		add: (MaTimeZone name: 'Irish Summer Time' abbreviation: 'IST' offset: 1 maHours) ;
		add: (MaTimeZone name: 'Kilo Time Zone' abbreviation: 'K' offset: 10 maHours) ;
		add: (MaTimeZone name: 'Lima Time Zone' abbreviation: 'L' offset: 11 maHours) ;
		add: (MaTimeZone name: 'Mike Time Zone' abbreviation: 'M' offset: 12 maHours) ;
		add: (MaTimeZone name: 'Mountain Daylight Time' abbreviation: 'MDT' offset: -6 maHours) ;
		add: (MaTimeZone name: 'Mountain Standard Time' abbreviation: 'MST' offset: -7 maHours) ;
		add: (MaTimeZone name: 'November Time Zone' abbreviation: 'MDT' offset: -1 maHours) ;
		add: (MaTimeZone name: 'Newfoundland Daylight Time' abbreviation: 'NDT' offset: -2 maHours - 30 maMinutes) ;
		add: (MaTimeZone name: 'Norfolk (Island) Time' abbreviation: 'NFT' offset: 11 maHours + 30 maMinutes) ;
		add: (MaTimeZone name: 'Newfoundland Standard Time' abbreviation: 'NST' offset: -3 maHours - 30 maMinutes) ;
		add: (MaTimeZone name: 'Oscar Time Zone' abbreviation: 'O' offset: -2 maHours) ;
		add: (MaTimeZone name: 'Papa Time Zone' abbreviation: 'P' offset: -3 maHours) ;
		add: (MaTimeZone name: 'Pacific Daylight Time' abbreviation: 'PDT' offset: -7 maHours) ;
		add: (MaTimeZone name: 'Pacific Standard Time' abbreviation: 'PST' offset: -8 maHours) ;
		add: (MaTimeZone name: 'Quebec Time Zone' abbreviation: 'Q' offset: -4 maHours) ;
		add: (MaTimeZone name: 'Romeo Time Zone' abbreviation: 'R' offset: -5 maHours) ;
		add: (MaTimeZone name: 'Sierra Time Zone' abbreviation: 'S' offset: -6 maHours) ;
		add: (MaTimeZone name: 'Tango Time Zone' abbreviation: 'T' offset: -7 maHours) ;
		add: (MaTimeZone name: 'Uniform Time Zone' abbreviation: 'U' offset: -8 maHours) ;
		add: (MaTimeZone name: 'Coordinated Universal Time' abbreviation: 'UTC' offset: 0 maHours) ;
		add: (MaTimeZone name: 'Victor Time Zone' abbreviation: 'V' offset: -9 maHours) ;
		add: (MaTimeZone name: 'Whiskey Time Zone' abbreviation: 'W' offset: -10 maHours) ;
		add: (MaTimeZone name: 'Western European Summer Time' abbreviation: 'WEST' offset: 1 maHours) ;
		add: (MaTimeZone name: 'Western European Time' abbreviation: 'WET' offset: 0 maHours) ;
		add: (MaTimeZone name: 'Western Standard Time' abbreviation: 'WST' offset: 8 maHours) ;
		add: (MaTimeZone name: 'Xray Time Zone' abbreviation: 'X' offset: -11 maHours) ;
		add: (MaTimeZone name: 'Yankee Time Zone' abbreviation: 'Y' offset: -12 maHours) ;
		add: (MaTimeZone name: 'Zulu Time Zone' abbreviation: 'Z' offset: 0 maHours)! !

!MaTimeZone class methodsFor: 'accessing' stamp: 'cmm 8/30/2004 11:44'!
localTimeZone

	^ LocalTimeZone! !

!MaTimeZone class methodsFor: 'accessing' stamp: 'cmm 8/30/2004 13:20'!
localTimeZone: aMaTimeZone

	LocalTimeZone _ aMaTimeZone! !

!MaTimeZone class methodsFor: 'create' stamp: 'cmm 8/30/2004 12:07'!
name: nameString abbreviation: abbreviationString offset: aMaDuration

	^ self new
		name: nameString ;
		abbreviation: abbreviationString ;
		offset: aMaDuration ;
		yourself! !

!MaTimeZone class methodsFor: 'accessing' stamp: 'cmm 8/30/2004 14:05'!
timeZoneAbbreviated: aString

	^ self timeZones detect: [ : each | each abbreviation = aString ]! !

!MaTimeZone class methodsFor: 'accessing' stamp: 'cmm 8/30/2004 13:24'!
timeZones

	^ AllTimeZones! !

!MaTimeZone methodsFor: 'accessing' stamp: 'cmm 8/30/2004 12:08'!
abbreviation
	"Answer the value of abbreviation"

	^ abbreviation! !

!MaTimeZone methodsFor: 'initialize' stamp: 'cmm 8/30/2004 12:08'!
abbreviation: anObject
	"Set the value of abbreviation"

	abbreviation _ anObject! !

!MaTimeZone methodsFor: 'accessing' stamp: 'cmm 8/30/2004 12:09'!
addLocation: locationString

	locations add: locationString! !

!MaTimeZone methodsFor: 'initialize' stamp: 'cmm 8/30/2004 12:09'!
initialize

	super initialize.
	locations _ Set new! !

!MaTimeZone methodsFor: 'accessing' stamp: 'cmm 8/30/2004 12:08'!
locations
	"Answer the value of locations"

	^ locations! !

!MaTimeZone methodsFor: 'printing' stamp: 'cmm 8/30/2004 13:25'!
maPrintAbbreviatedOn: aStream

	aStream
		print: self abbreviation! !

!MaTimeZone methodsFor: 'accessing' stamp: 'cmm 8/30/2004 12:08'!
name

	^ name! !

!MaTimeZone methodsFor: 'initialize' stamp: 'cmm 8/30/2004 12:08'!
name: anObject
	"Set the value of name"

	name _ anObject! !

!MaTimeZone methodsFor: 'accessing' stamp: 'cmm 8/30/2004 12:08'!
offset
	"Answer the value of offset"

	^ offset! !

!MaTimeZone methodsFor: 'initialize' stamp: 'cmm 8/30/2004 12:08'!
offset: anObject
	"Set the value of offset"

	offset _ anObject! !

!MaTimeZone methodsFor: 'accessing' stamp: 'cmm 8/30/2004 12:10'!
removeLocation: locationString

	locations remove: locationString! !

Magnitude subclass: #MaCalendarTime
	instanceVariableNames: 'totalMilliseconds'
	classVariableNames: 'FirstTimestampMillisecond FirstRecordedMillisecondClock BaseCalendarDate'
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaCalendarTime commentStamp: '<historical>' prior: 0!
I represent a calendar time; either a duration represented in units of a Gregorian calendar (days, hours, minutes, seconds, etc.) or a point on the timeline of the Gregorian calendar.

I support full arithmetic with other CalendarTimes and Integers as it makes sense.  For example, dividing 30 minutes by 3 makes sense, but not May 19th, 1969.

I have fairly efficient storage, a single integer of the total number of milliseconds that have elapsed since my base time, 1/1/1901 @ 12:00am.
!

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:40'!
date: aDate time: aTime

	^self fromSeconds: aDate asSeconds + aTime asSeconds
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:50'!
date: aDate time: aTime milliseconds: anInteger

	^self fromMilliseconds: (aDate asSeconds + aTime asSeconds) * 1000 + anInteger
! !

!MaCalendarTime class methodsFor: 'private' stamp: 'cmm 3/7/2002 22:51'!
durationFromStream: aReadStream plusMilliseconds: anInteger ifInvalid: aBlock
	"Correct form is hh:mm:ss.nnn."

	| hours minutes seconds subseconds |

	(hours _ (aReadStream upTo: $:) asNumber) isNil ifTrue: [ ^aBlock value ].
	(minutes _ (aReadStream upTo: $:) asNumber) isNil ifTrue: [ ^aBlock value ].
	(seconds _ (aReadStream upTo: $.) asNumber) isNil ifTrue: [ ^aBlock value ].
	(subseconds _ aReadStream upToEnd asNumber) isNil ifTrue: [ ^aBlock value ].
	subseconds > 999 ifTrue: [ ^aBlock value ].
	^self fromMilliseconds:
		anInteger + (hours * 3600 * 1000) + (minutes * 60 * 1000) + (seconds * 1000) + subseconds
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:51'!
epoch
	"Return a new instance of the receiver with its time set to 0.
	This is useful for timing operations."

	^self fromMilliseconds: 0
! !

!MaCalendarTime class methodsFor: 'private' stamp: ''!
fromDurationString: aString ifInvalid: aBlock
	"Correct form is hh:mm:ss.nnn."

	| stream |

	stream _ ReadStream on: aString trimBlanks.
	^self
		durationFromStream: stream
		plusMilliseconds: 0
		ifInvalid: aBlock
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:44'!
fromMilliseconds: anInteger

	^self new totalMilliseconds: anInteger
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:39'!
fromSeconds: anInteger

	"Returns a new instance of the receiver based on anInteger seconds."

	^self new totalSeconds: anInteger
! !

!MaCalendarTime class methodsFor: 'creation' stamp: ''!
fromString: aString
	"Correct form is 'yyyy/mm/dd hh:mm:ss:nnn' or 'hh:mm:ss.nnn'
	if you intend to use the new instance as a 'duration'."

	^self
		fromString: aString
		ifInvalid: [ self error: aString, ' is not formatted properly for the default, simple parser.' ]
! !

!MaCalendarTime class methodsFor: 'creation' stamp: ''!
fromString: aString ifInvalid: aBlock
	"Correct form is 'yyyy/mm/dd hh:mm:ss:nnn' or 'hh:mm:ss.nnn'
	if you intend to use the new instance as a 'duration'."

	^aString size = 12
		ifTrue:
			[ self
				fromDurationString: aString
				ifInvalid: aBlock ]
		ifFalse:
			[ self
				fromTimeStampString: aString
				ifInvalid: aBlock ]
! !

!MaCalendarTime class methodsFor: 'private' stamp: 'cmm 3/7/2002 22:31'!
fromTimeStampString: aString ifInvalid: aBlock
	"Correct form is yyyy/mm/dd hh:mm:ss.mmm"

	| stream year month day |

	stream _ ReadStream on: aString.
	(year _ (stream upTo: $/) asNumber) isNil ifTrue: [ ^aBlock value ].
	(month _ (stream upTo: $/) asNumber) isNil ifTrue: [ ^aBlock value ].
	(day _ (stream upTo: $ ) asNumber) isNil ifTrue: [ ^aBlock value ].
	^self
		durationFromStream: stream
		plusMilliseconds:
			(Date
				newDay: day
				month: month
				year: year)
					asSeconds * 1000
		ifInvalid: aBlock
! !

!MaCalendarTime class methodsFor: 'initializing' stamp: 'cmm 4/29/2003 23:16'!
initialize

	Smalltalk addToStartUpList: self.
	FirstRecordedMillisecondClock _ Time millisecondClockValue.
	FirstTimestampMillisecond _ (Date today asSeconds + Time now asSeconds) * 1000.
	BaseCalendarDate _ Date newDay: 1 month: 1 year: 1901! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:51'!
now
	"answer a new timestamp for the current date and time."

	^self fromMilliseconds:
		(Time millisecondClockValue - FirstRecordedMillisecondClock + FirstTimestampMillisecond)
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/6/2002 22:13'!
secondsPerDay

	^86400
! !

!MaCalendarTime class methodsFor: 'initializing' stamp: 'cmm 3/18/2002 22:20'!
startUp: amResumingPreviouslySavedImage
	"amResumingPreviouslySavedImage is a boolean..  How about that?"

	super startUp: amResumingPreviouslySavedImage.
	self initialize
! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 2/2/2003 10:53'!
+ aMaCalendarTime

	^self class fromMilliseconds: totalMilliseconds + aMaCalendarTime totalMilliseconds! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 2/2/2003 11:01'!
- aMaCalendarTimeOrDuration

	^(aMaCalendarTimeOrDuration isDuration
		ifTrue: [ MaCalendarTime ]
		ifFalse: [ MaDuration ])
			fromMilliseconds: self totalMilliseconds - aMaCalendarTimeOrDuration totalMilliseconds! !

!MaCalendarTime methodsFor: 'comparing' stamp: 'cmm 3/6/2002 23:29'!
< aMaCalendarTime

	^self totalMilliseconds < aMaCalendarTime totalMilliseconds
! !

!MaCalendarTime methodsFor: 'comparing' stamp: 'cmm 12/23/2002 16:21'!
= aMaCalendarTime 
	aMaCalendarTime class = self class ifFalse: [^false].
	^self totalMilliseconds = aMaCalendarTime totalMilliseconds! !

!MaCalendarTime methodsFor: 'printing' stamp: 'cmm 2/5/2003 20:11'!
abbreviatedString

	^String streamContents: [ :stream | self maPrintAbbreviatedOn: stream ]! !

!MaCalendarTime methodsFor: 'as yet unclassified' stamp: 'cmm 8/31/2004 00:23'!
asGmt

	^ self asTimeIn: MaTimeZone gmt! !

!MaCalendarTime methodsFor: 'as yet unclassified' stamp: 'cmm 8/30/2004 14:12'!
asLocalTime

	^ self asTimeIn: MaTimeZone localTimeZone! !

!MaCalendarTime methodsFor: 'as yet unclassified' stamp: 'cmm 8/30/2004 14:00'!
asTimeIn: aMaTimeZone

	^ self + aMaTimeZone offset - self timeZone offset! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 22:57'!
date

	^Date fromDays: self totalDays
! !

!MaCalendarTime methodsFor: 'building' stamp: 'cmm 3/7/2002 23:00'!
date: aDate time: aTime

	^self
		date: aDate
		time: aTime
		milliseconds: 0
! !

!MaCalendarTime methodsFor: 'building' stamp: 'cmm 3/7/2002 22:59'!
date: aDate time: aTime milliseconds: anInteger

	self totalMilliseconds: (aDate asSeconds + aTime asSeconds) * 1000 + anInteger
! !

!MaCalendarTime methodsFor: 'private' stamp: 'cmm 2/2/2003 10:42'!
hash

	^self totalMilliseconds hash! !

!MaCalendarTime methodsFor: 'testing' stamp: 'cmm 2/2/2003 11:02'!
isDuration

	^false! !

!MaCalendarTime methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:32'!
maPrintAbbreviatedOn: aStream

	aStream
		print: self date;
		space;
		print: self time! !

!MaCalendarTime methodsFor: 'accessing' stamp: ''!
milliseconds

	^self totalMilliseconds \\ 1000
! !

!MaCalendarTime methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:33'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:50'!
roundTo: aMaCalendarTime
	"aMaCalendarTime should be a duration.
	i.e., if the receiver is 5 minutes, 37 seconds, and aMaCalendarTime
	is 2 minutes, then return 6 minutes."

	^self class fromMilliseconds: (self totalMilliseconds roundTo: aMaCalendarTime totalMilliseconds)
! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 22:57'!
time

	^Time fromSeconds: self totalSeconds
! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 8/30/2004 13:50'!
timeZone

	^ MaTimeZone localTimeZone! !

!MaCalendarTime methodsFor: 'experimental' stamp: 'cmm 3/3/2004 13:00'!
to: aMaCalendarTime

	^self
		to: aMaCalendarTime
		by: 1 maSecond! !

!MaCalendarTime methodsFor: 'experimental' stamp: ''!
to: endTimeStamp by: stepDuration

	^MaTimeInterval
		from: self
		to: endTimeStamp
		by: stepDuration
! !

!MaCalendarTime methodsFor: 'experimental' stamp: ''!
to: endTimeStamp by: durationIncrement do: aBlock
	"Evaluate aBlock for each MaTimeStamp element in the interval.
	Return stop."

	(self
		to: endTimeStamp
		by: durationIncrement) do: [ :each | aBlock value: each ].	
	^endTimeStamp
! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 12/23/2002 16:27'!
totalDays

	^self totalSeconds // self class secondsPerDay
! !

!MaCalendarTime methodsFor: 'accessing' stamp: ''!
totalMilliseconds

	^totalMilliseconds! !

!MaCalendarTime methodsFor: 'accessing' stamp: ''!
totalMilliseconds: anInteger

	totalMilliseconds _ anInteger
! !

!MaCalendarTime methodsFor: 'accessing' stamp: ''!
totalSeconds

	^self totalMilliseconds // 1000
! !

!MaCalendarTime methodsFor: 'private' stamp: ''!
totalSeconds: anInteger

	self totalMilliseconds: anInteger * 1000
! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:50'!
truncateTo: aMaCalendarTime
	"aMaCalendarTime should be a duration.
	i.e., if the receiver is 5 minutes, 37 seconds, and duration
	is 2 minutes, then return 4 minutes."

	^self class
		fromMilliseconds: (self totalMilliseconds truncateTo: aMaCalendarTime totalMilliseconds)
! !

MaCalendarTime subclass: #MaDuration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaDuration methodsFor: 'operators' stamp: 'cmm 2/2/2003 10:39'!
* anInteger

	^self class fromMilliseconds: self totalMilliseconds * anInteger! !

!MaDuration methodsFor: 'operators' stamp: 'cmm 2/2/2003 11:46'!
- aMaDuration

	^self class fromMilliseconds: self totalMilliseconds - aMaDuration totalMilliseconds! !

!MaDuration methodsFor: 'operators' stamp: 'cmm 2/2/2003 10:35'!
// anIntegerOrCalendarTime

	^anIntegerOrCalendarTime maDivideIntoDuration: self! !

!MaDuration methodsFor: 'operators' stamp: 'cmm 2/2/2003 10:37'!
\\ anIntegerOrDuration

	^anIntegerOrDuration maModuloDuration: self! !

!MaDuration methodsFor: 'testing' stamp: 'cmm 2/2/2003 11:02'!
isDuration

	^true! !

!MaDuration methodsFor: 'private' stamp: 'cmm 2/2/2003 10:34'!
maDivideIntoDuration: aMaCalendarTime

	^self class fromMilliseconds: aMaCalendarTime totalMilliseconds // self totalMilliseconds! !

!MaDuration methodsFor: 'private' stamp: 'cmm 2/2/2003 10:38'!
maModuloDuration: aMaCalendarTime

	^self class fromMilliseconds: aMaCalendarTime totalMilliseconds \\ self totalMilliseconds! !

!MaDuration methodsFor: 'printing' stamp: 'cmm 2/5/2003 20:06'!
maPrintAbbreviatedOn: aStream

	(self totalSeconds >= self class secondsPerDay)
		ifTrue:
			[ aStream
				print: (self date subtractDate: BaseCalendarDate);
				nextPutAll: ' days, ' ].
	aStream 
		nextPutAll: self time print24;
		nextPut: $.;
		maPrintNumber: self milliseconds
		template: '000'! !

MaCalendarTime subclass: #MaGlobalTime
	instanceVariableNames: 'timeZone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaGlobalTime methodsFor: 'accessing' stamp: 'cmm 8/30/2004 13:52'!
initialize

	super initialize.
	timeZone _ MaTimeZone localTimeZone! !

!MaGlobalTime methodsFor: 'accessing' stamp: 'cmm 8/30/2004 13:21'!
timeZone

	^ timeZone! !

!MaGlobalTime methodsFor: 'accessing' stamp: 'cmm 8/30/2004 13:21'!
timeZone: aMaTimeZone

	timeZone _ aMaTimeZone! !

Object subclass: #MaStopwatch
	instanceVariableNames: 'startTime stoppedTime totalStoppedTime state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaStopwatch class methodsFor: 'examples' stamp: ''!
example1

	|s|
	s _ MaStopwatch new start.
	(Delay forSeconds: 3) wait.
	Transcript cr; show: s time printString.
	s reset.
	Transcript cr; show: s time printString.
! !

!MaStopwatch class methodsFor: 'instance creation' stamp: ''!
new

	^super new initialize
! !

!MaStopwatch methodsFor: 'private' stamp: 'cmm 10/30/2002 21:24'!
beRunning

	state _ #running! !

!MaStopwatch methodsFor: 'private' stamp: 'cmm 10/30/2002 22:03'!
beStopped

	state _ #stopped! !

!MaStopwatch methodsFor: 'private' stamp: 'cmm 1/30/2003 12:34'!
initialize

	self reset! !

!MaStopwatch methodsFor: 'testing' stamp: 'cmm 10/30/2002 22:22'!
isRunning

	^state = #running! !

!MaStopwatch methodsFor: 'testing' stamp: ''!
isStarted

	^self isRunning or: [ self time > 0 seconds ]
! !

!MaStopwatch methodsFor: 'testing' stamp: 'cmm 10/30/2002 22:22'!
isStopped

	^state = #stopped! !

!MaStopwatch methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:32'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $ .
	self time maPrintAbbreviatedOn: aStream! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 3/3/2004 12:59'!
reset

	self beStopped.
	totalStoppedTime _ 0 maSeconds.
	stoppedTime _ nil.
	startTime _ nil! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 1/8/2003 23:53'!
restart

	self reset; start! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 3/3/2004 12:58'!
start

	self isRunning ifTrue: [ ^self ].
	startTime
		ifNil:
			[ startTime _ MaCalendarTime now.
			stoppedTime _ startTime.
			totalStoppedTime _ 0 maSeconds ]
		ifNotNil:
			[ totalStoppedTime _ totalStoppedTime + MaCalendarTime now - stoppedTime ].
	self beRunning! !

!MaStopwatch methodsFor: 'accessing' stamp: ''!
startTime

	"The point in time which the receiver was started."

	^startTime
! !

!MaStopwatch methodsFor: 'private' stamp: ''!
state

	^state
! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 2/2/2003 11:41'!
stop

	self isRunning
		ifTrue:
			[ stoppedTime _ MaCalendarTime now.
			self beStopped ].
	^stoppedTime! !

!MaStopwatch methodsFor: 'accessing' stamp: 'cmm 3/3/2004 12:58'!
time
	"Return an MaDuration representing the total time the stopwatch has run."

	^self isRunning
		ifTrue: [ MaCalendarTime now - startTime - totalStoppedTime ]
		ifFalse:
			[ startTime
				ifNil: [ 0 maSeconds ]
				ifNotNil: [ stoppedTime - startTime - totalStoppedTime ] ]! !

!MaStopwatch methodsFor: 'private' stamp: ''!
totalStoppedTime

	^totalStoppedTime
! !

!MaStopwatch methodsFor: 'private' stamp: ''!
totalStoppedTime: anInteger

	"Set the totalStoppedTime to anInteger number of milliseconds."

	totalStoppedTime _ anInteger
! !

Object subclass: #MaTimeInterval
	instanceVariableNames: 'from to by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Experimental'!

!MaTimeInterval class methodsFor: 'creation' stamp: 'cmm 3/3/2004 13:17'!
dayOf: aMaCalendarTime by: resolution
	"Returns the calandar day surrounding aMaTimestamp."

	| begin |

	begin _ aMaCalendarTime truncateTo: 1 maDay.
	^self
		from: begin
		to: begin + MaCalendarTime maDay - resolution
		by: resolution
! !

!MaTimeInterval class methodsFor: 'creation' stamp: ''!
from: fromTimeStamp to: toTimeStamp

	^self new
		from: fromTimeStamp;
		to: toTimeStamp
! !

!MaTimeInterval class methodsFor: 'creation' stamp: ''!
from: startTimeStamp to: endTimeStamp by: byTimeStamp

	^self new
		from: startTimeStamp;
		to: endTimeStamp;
		by: byTimeStamp
! !

!MaTimeInterval class methodsFor: 'creation' stamp: 'cmm 3/3/2004 13:14'!
hourOf: aMaCalendarTime by: resolution
	"Returns the calandar hour surrounding aMaCalendarTime."

	| begin |

	begin _ aMaCalendarTime truncateTo: 1 maHour.
	^self
		from: begin
		to: begin + 1 maHour - resolution
		by: resolution! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
after: aMaTimeStamp
	"Answer the first timeStamp 'included' in the receiver that is higher
	than aMaTimeStamp"

	^(aMaTimeStamp + (by // 2)) roundTo: by
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
at: anInteger

	^from + (by * anInteger)
! !

!MaTimeInterval methodsFor: 'improper' stamp: ''!
at: anInteger put: anObject

	self shouldNotImplement
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
before: aMaTimeStamp
	"Answer the timeStamp 'included' in the receiver that is the first
	one lower than aMaTimeStamp"

	^(aMaTimeStamp - (by / 2)) roundTo: by
! !

!MaTimeInterval methodsFor: 'private accessing' stamp: ''!
by

	^by! !

!MaTimeInterval methodsFor: 'private building' stamp: ''!
by: aMaTimeStamp

	by _ aMaTimeStamp
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
collect: aBlock

	| answer index |

	answer _ Array new: self size.
	index _ 1.
	self do:
		[ :each |
		answer
			at: index
			put: (aBlock value: each).
		index _ index + 1 ].
	^answer
! !

!MaTimeInterval methodsFor: 'actions' stamp: ''!
do: aBlock

	| element |

	element _ from.
	self size timesRepeat:
		[ aBlock value: element.
		element _ element + by ]
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
duration

	^to - from
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
first

	(to - from // by) >= 0
		ifTrue:
			[ ^from ]
		ifFalse:
			[ self error: self printString , ' is empty.' ]
! !

!MaTimeInterval methodsFor: 'private accessing' stamp: ''!
from

	^from! !

!MaTimeInterval methodsFor: 'private building' stamp: ''!
from: aMaTimeStamp

	from _ aMaTimeStamp
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
increment

	^by
! !

!MaTimeInterval methodsFor: 'testing' stamp: ''!
intersects: anInterval
	"Return true if the receiver overlaps with anInterval."

	^(self from
		between: anInterval from
		and: anInterval to)
			or:
				[ anInterval from
					between: self from
					and: self to ]
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
last

	| last |

	(last _ to - from // by) >= 0
		ifTrue:
			[ ^from + (last * by) ]
		ifFalse:
			[ self error: self printString, ' is empty.' ]
! !

!MaTimeInterval methodsFor: 'testing' stamp: ''!
maIntersects: anInterval 
	"Return true if the receiver overlaps with anInterval."

	^(self from between: anInterval from and: anInterval to) 
		or: [anInterval from between: self from and: self to]! !

!MaTimeInterval methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:33'!
maPrintAbbreviatedOn: aStream

	aStream
		maPrintAbbreviated: from;
		nextPutAll: ' to: ';
		maPrintAbbreviated: to;
		nextPutAll: ' by: ';
		maPrintAbbreviated: by
! !

!MaTimeInterval methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:33'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
reject: aBlock

	| answer index |

	answer _ Array new: self size.
	index _ 0.
	self do:
		[ :each |
		(aBlock value: each)
			ifFalse:
				[ answer
					at: (index _ index + 1)
					put: each ] ].
	^answer
		copyFrom: 1
		to: index
! !

!MaTimeInterval methodsFor: 'creation' stamp: ''!
reverse

	^self class
		from: to
		to: from
		by: by
! !

!MaTimeInterval methodsFor: 'actions' stamp: ''!
reverseDo: aBlock

	| element selfSize |

	element _ from + ((selfSize _ self size) - 1 * by).
	selfSize timesRepeat:
		[ aBlock value: element.
		element _ element - by ]
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
select: aBlock

	| answer index |

	answer _ Array new: self size.
	index _ 0.
	self do:
		[ :each |
		(aBlock value: each)
			ifTrue:
				[ answer
					at: (index _ index + 1)
					put: each ] ].
	^answer
		copyFrom: 1
		to: index
! !

!MaTimeInterval methodsFor: 'accessing' stamp: ''!
size

	^self duration // by
! !

!MaTimeInterval methodsFor: 'private accessing' stamp: ''!
to

	^to! !

!MaTimeInterval methodsFor: 'private building' stamp: ''!
to: aMaTimeStamp

	to _ aMaTimeStamp
! !

MaNotification subclass: #MaProgressNotification
	instanceVariableNames: 'attributes advanceCount signalFrequency timeSinceLastSignal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-exceptions'!

!MaProgressNotification methodsFor: 'actions' stamp: 'cmm 1/18/2004 22:33'!
advance

	(Delay forMilliseconds: 0) wait. "this should eliminate a lot of need for various Processor yields."
	timeSinceLastSignal start.
	advanceCount _ advanceCount + 1! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 1/18/2004 22:32'!
advanceCount

	^advanceCount! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 11/13/2003 00:47'!
description

	^attributes at: 'description' ifAbsent: [ '' ]! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:09'!
description: aString

	attributes at: 'description' put: aString! !

!MaProgressNotification methodsFor: 'testing' stamp: 'cmm 8/6/2003 00:59'!
hasDescription

	^attributes includesKey: 'description'! !

!MaProgressNotification methodsFor: 'testing' stamp: 'cmm 8/6/2003 01:00'!
hasLogMessage

	^attributes includesKey: 'logMessage'! !

!MaProgressNotification methodsFor: 'testing' stamp: 'cmm 8/6/2003 00:59'!
hasTaskSize

	^attributes includesKey: 'taskSize'! !

!MaProgressNotification methodsFor: 'testing' stamp: 'cmm 8/6/2003 00:59'!
hasUnitsCompleted

	^attributes includesKey: 'unitsCompleted'! !

!MaProgressNotification methodsFor: 'testing' stamp: 'cmm 8/6/2003 00:59'!
hasUnitsVerbPhrase

	^attributes includesKey: 'unitsVerbPhrase'! !

!MaProgressNotification methodsFor: 'initializing' stamp: 'cmm 3/3/2004 12:59'!
initialize

	super initialize.
	attributes _ Dictionary new.
	self signalFrequency: 4 maSeconds.
	timeSinceLastSignal _ MaStopwatch new.
	advanceCount _ 0! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/6/2003 00:40'!
logMessage

	^attributes at: 'logMessage'! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:27'!
logMessage: aString

	attributes at: 'logMessage' put: aString! !

!MaProgressNotification methodsFor: 'testing' stamp: 'cmm 8/6/2003 00:41'!
shouldAdvance

	^attributes includesKey: 'shouldAdvance'! !

!MaProgressNotification methodsFor: 'actions' stamp: 'cmm 1/18/2004 22:34'!
signal

	super signal.
	timeSinceLastSignal restart.
	advanceCount _ 0! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 11/13/2003 00:27'!
signalFrequency: aMaDuration

	signalFrequency _ aMaDuration! !

!MaProgressNotification methodsFor: 'actions' stamp: 'cmm 11/13/2003 23:50'!
signalIfTime

	timeSinceLastSignal time > signalFrequency ifTrue: [ self signal ]! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/6/2003 00:40'!
taskSize

	^attributes at: 'taskSize'! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:10'!
taskSize: anInteger

	attributes at: 'taskSize' put: anInteger! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 11/13/2003 00:46'!
unitsCompleted

	^attributes at: 'unitsCompleted' ifAbsent: [ 0 ]! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:18'!
unitsCompleted: anInteger

	attributes at: 'unitsCompleted' put: anInteger! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 11/13/2003 00:46'!
unitsVerbPhrase

	^attributes at: 'unitsVerbPhrase' ifAbsent: [ '' ]! !

!MaProgressNotification methodsFor: 'accessing' stamp: 'cmm 8/4/2003 23:18'!
unitsVerbPhrase: anInteger

	attributes at: 'unitsVerbPhrase' put: anInteger! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:17'!
maDay

	^self maDays
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:01'!
maDays

	^MaDuration fromSeconds: self * MaCalendarTime secondsPerDay! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 2/2/2003 10:10'!
maDivideIntoCalendarTime: aMaDuration

	^MaDuration fromMilliseconds: aMaDuration totalMilliseconds // self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 2/2/2003 10:34'!
maDivideIntoDuration: aMaDuration

	^MaDuration fromMilliseconds: aMaDuration totalMilliseconds // self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:15'!
maHour

	^self maHours
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:04'!
maHours

	^MaDuration fromSeconds: self * 3600 "seconds in an hour"! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:15'!
maMillisecond
	"Return an MaDuration (to be used as a magnitude) with
	a magnitude of the number of milliseconds the receiver represents."

	^self maMilliseconds! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:10'!
maMilliseconds
	"Return an MaDuration (to be used as a magnitude) with
	a magnitude of the number of milliseconds the receiver represents."

	^MaDuration fromMilliseconds: self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:21'!
maMinute

	^ self maMinutes! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:21'!
maMinutes

	^MaDuration fromSeconds: self * 60
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 2/2/2003 10:38'!
maModuloDuration: aMaDuration

	^MaDuration fromMilliseconds: aMaDuration totalMilliseconds \\ self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 8/24/2004 13:30'!
maSecond

	^self maSeconds
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 12:58'!
maSeconds
	"Return an MaDuration (to be used as a magnitude) with a magnitude of the number of seconds the receiver represents."

	^MaDuration fromSeconds: self! !

!Delay class methodsFor: '*ma time objects' stamp: 'cmm 12/19/2002 23:38'!
for: aMaCalendarTime
	"Example:
		(Delay for: 10 seconds) wait"

	^self forMilliseconds: aMaCalendarTime totalMilliseconds! !

!DirectoryEntry methodsFor: '*ma time objects' stamp: 'cmm 3/11/2003 23:39'!
maCreationTime

	^MaCalendarTime fromSeconds: creationTime! !

!DirectoryEntry methodsFor: '*ma time objects' stamp: 'cmm 3/11/2003 23:41'!
maModificationTime

	^MaCalendarTime fromSeconds: modificationTime! !

PackageInfo subclass: #MaTimeObjectsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Info'!

!MaTimeObjectsPackageInfo methodsFor: 'accessing' stamp: 'cmm 3/21/2004 16:39'!
prerequisitePackages
	^ #( 'Ma base additions' )! !

!MaTimeObjectsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 4/2/2004 12:53'!
readmeText

	^'I can help you deal with aspects of time using a pleasant API.  The core domain class is MaCalendarTime, which can represent either a point on the Gregorian calendar, or a duration of Gregorian time (e.g., seconds, days, etc.).  MaCalendarTime is storage efficient, wrapping only a single Integer, and is precise to the millisecond.

To get the current time, precise to the millisecond:

	MaCalendarTime now

To obtain a duration:

	3 maMinutes

A variety of arithmetic is supported:

	3 maMinutes + 2 maSeconds
	8 maHours // 2
	(1 maHour + 27  maMinutes) roundTo: 30 maMinutes
	MaCalendarTime now - 30 maDays
	MaCalendarTime now - (MaCalendarTime fromString: ''1969/12/31 23:52:59.999'')

*** MaStopwatch ***
is the other cool domain class.  This is, literally, a stopwach just like you would use in real life.  I use it to time things, such as how long it has been since I last signaled a ProgressNotification, that way I can do them only ever five seconds or so.  Inspect this and play with it, it''s simple:

	MaStopwatch new start
'! !

!BlockContext methodsFor: '*ma time objects' stamp: 'cmm 12/5/2002 21:46'!
maCalendarTimeToRun

	| start |
	start _ MaCalendarTime now.
	self value.
	^MaCalendarTime now - start! !
MaTimeZone initialize!
MaCalendarTime initialize!
